from math import *
import numpy as np
from sklearn import tree
import pandas
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
#for price calculation part
from itertools import combinations

# reading file with panda

data = pandas.read_csv('/Users/clarajenft/Downloads/data.csv', sep=";",)



# Labels discretisation


newlabel=[]
label=data['label']
for n in range (len(label)):
    if ((type(label[n])) != int):

        if (label[n]<0.5):
            newlabel.append(0)
        else :
            newlabel.append(1)

data['newlabel']=newlabel



# Divide the data into training and testing

x_train, x_test, y_train, y_test = train_test_split(data[["Tin","Tout","humidity","detected_motions","power","office_CO2_concentration","Door","CO2_corridor","acoustic_pressure_dB"]],data[['newlabel']],test_size=.1,random_state=0)

# Define the most important features
def importance (x_train, y_train) :
    classifier = tree.DecisionTreeClassifier(random_state=0, criterion='entropy', max_depth=None) 
    classifier.fit(x_train, y_train) 
    important = classifier.feature_importances_
    return important

most_important= importance (x_train, y_train)
print("most_important",most_important)


# implementation of decision tree

def decision_tree(x_test,y_test,x_train,y_train) :

    classifier=tree.DecisionTreeClassifier(max_depth=3)
    classifier.fit(x_train,y_train)
    prediction=classifier.predict(x_test)
    accuracy = classifier.score(x_test, y_test)
    print("accuracy", accuracy)
    features_importance= classifier.feature_importances_
    #print(" feature_ importance",features_importance)
    indices=np.argsort(features_importance)
    # plt.title('feature importance')
    # plt.barh(range(len(indices)), features_importance[indices], color = 'b', align = 'center')
    # plt.yticks(range(len(indices)), [x_train.columns.values[i] for i in indices])
    # plt.xlabel('Relative importance')
    with open ("MLClaraJenft.dot","w") as file :
        f=tree.export_graphviz(classifier,out_file=file)
    return(prediction, accuracy)


    

#change the depth

(prediction, accu) = decision_tree(x_test,y_test,x_train,y_train)
print("the predicted occupancy is: \n",prediction)


def accurary_dif_depths(size):
    depth = [] #abcisse
    accuracy = []  #ordonnée
      #show the accuracy from 1 to size-1
    for i in range(1, size):
        classifier=tree.DecisionTreeClassifier(max_depth=i)
        classifier.fit(x_train,y_train)
        depth.append(i)
        accuracy.append(classifier.score(x_test, y_test))  #accuracy for dpth = 1
        #print( i, classifier.score(x_test, y_test)) #to test
    #show the accuracy for 'None' last
    classifier=tree.DecisionTreeClassifier(max_depth=None)
    classifier.fit(x_train,y_train)
    depth.append(i)
    accuracy.append(classifier.score(x_test, y_test))
    plt.plot(depth, accuracy)
    return (depth, accuracy)

(depth,accuracy) = accurary_dif_depths(8) #we show the plot




# print ("data : ", data)  
# data2 = data["power"]
# print ("data : ", data2)




#calculation price

def calcul_efficiency(x_test,y_test,x_train,y_train) :
    list_effective=[]
    list_price=[]
    list_accuracy=[]
    max_efficient = 0
    #test all combinasion of sensors, to define the best deal accuracy/price
    sensors = ["Tin","Tout","humidity","detected_motions","power","office_CO2_concentration","Door","CO2_corridor","acoustic_pressure_dB"]
    for i in range(1, len(sensors)-7):
        for tuple_combi in combinations(sensors, i) : #test all combinaison possible between sensors
            combi=[]   
            for i in tuple_combi:
                combi.append(i)    #convert tuple into list
            print(combi)
            #divide new data into training and testing
            x_test2 = x_test[combi]
            x_train2 = x_train[combi]
            
            """other code solution: def function without arguments, no xtest2 and xtrain2, only the line below. 
But in this case, the xtrain and xtest are different at each iteration"""
            #x_train, x_test, y_train, y_test = train_test_split(data[combi],data[['newlabel']],test_size=.1,random_state=0)
            
            #calculate accuracy of the combinaison with DT (depth = 3) att: change in DT fct
            (pred, accu) = decision_tree(x_test2, y_test, x_train2, y_train)
            #define price of all components of the combi
            price_of_combi = calcul_price(combi)
            #print(price_of_combi)
            #print(combi)
            #efficiency of each combi (define by myself, can be modulable : acc +1/price)
            effective = accu + 0/price_of_combi
            #stock the most efficent
            if effective >max_efficient:
                best_combi = combi
                max_efficient = effective
            #for plots (optionnal)
            list_effective.append(effective)
            list_price.append(price_of_combi)
            list_accuracy.append(accu)
    """choose the plot you want to study"""
    #plt.plot(list_effective)
    #plt.plot(list_price)  
    #plt.plot(list_accuracy)
    return(best_combi)




#define the price of a combinaison of sensors
#the price was defined after internet research
def calcul_price(combination):
    chaine = ' '.join(combination) #convert list into string
    price=0
    if (chaine.find("Tin") != -1):
        price += 4
    if (chaine.find("Tout") != -1):
        price += 4
    if (chaine.find("humidity") != -1):
        price += 7
    if (chaine.find("detected_motions") != -1):
        price += 15
    if (chaine.find("power") != -1):
        price += 40
    if (chaine.find("office_CO2_concentration") != -1):
        price += 25
    if (chaine.find("Door") != -1):
        price += 7
    if (chaine.find("CO2_corridor") != -1):
        price += 25
    if (chaine.find("acoustic_pressure_dB") != -1):
        price += 10
    return (price)




calcul = calcul_efficiency(x_test,y_test,x_train,y_train)
print("The best combinaison is ", calcul)

#plot test occ real occ

 

#accuracy and average error
# average_error = 0


#
# average_error =  average_error/len(y_test)
# accurancy = accurancy/len(y_test)*100
# print ("the aaccurancy is (in %):\n ", accurancy)
# print ("the average error is :\n ", average_error)

