import numpy as np
import matplotlib.pyplot as plt
from sklearn import tree
from sklearn import metrics
import pandas
from sklearn.model_selection import train_test_split
import graphviz
import time
import datetime
from sklearn.cluster import KMeans

""""""""""""""""" to read and put in form datas """""""""""""""


def stringdate_to_datetime(stringdatetime: str):
    if "." in stringdatetime:
        stringdatetime = stringdatetime.split(".")[0]

    else:
        stringdatetime = stringdatetime.split("Z")[0]

    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))


# lecture csv

def lire_csv(filename):
    # read csv and convert to data frame
    selected_attribute = pandas.read_csv(filename, sep=",")
    selected_attribute["datetime"] = selected_attribute["time"].apply(
        stringdate_to_datetime)
    sa = selected_attribute[['value', 'datetime']]
    sa.set_index('datetime', inplace=True)
    # fill gaps
    print("isnull", sa.isnull().any())
    sa.ffill()  # interpolate pour prendre une valeur moyenne entre la valeur prec et suivante
    #  resample data
    sa = sa.resample('40T').sum()
    return sa


Tv_power = lire_csv("TV_power.csv")
fenetre = lire_csv("fenetre.csv")
humidity = lire_csv("humidity.csv")
chauffage = lire_csv("chauffage.csv")
lumiere = lire_csv("lumiere.csv")
temperature = lire_csv("temperature.csv")
C02 = lire_csv("CO2.csv")
box = lire_csv("box_tv.csv")
bruit = lire_csv("bruit.csv")

result = pandas.concat([humidity, C02, fenetre, chauffage,
                       temperature, lumiere, Tv_power], axis=1, join='inner')
result.columns = ["humidity", "C02", "fenetre",
                  "chauffage", "temperature", "lumiere", "Tv_power"]

# print("C02")
# print (result["C02"])

# print("\nfenetre")
# print (result["fenetre"])

# print("\nchauffage")
# print (result["chauffage"])


data = result.copy

print(data)


""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

""""""""""""""""""""""""""""""""""determin occupancy whith KMeans"""""""""""""""""""""""

# def nb_collums (data):
#     nb = len (data.axes[1])
#     return (nb)


# # def normalize(data) :

# #     for columns in nb_collums(data):
# #        title
# #         for line in len(data):
# #             x_norm = ((data[data.axes[1][columns]][line])-x_min)/(x_max-x_min)
# #             data_norm.append(x_norm)


# # def determine_occupation (data) :

# #     #distance Entre les différents points de données.
# #     #On utilisera la distance euclidienne sur les données normalisé

# #     #Normalisation des données

# #     for collums in nb_collums(data):#Nombre entre 0 et 9
# #         for line in len (data) :#Nombre entre 0 et 600 et quelques


# column_x = []
# for i in range (len(data)):
#     column_x.append(i)
# data["abcisse_time"]=column_x

# print(data)

# from pandas.plotting import scatter_matrix
# scatter_matrix(data,figsize=(nb_collums(data),nb_collums(data)))

# from sklearn import cluster
# kmeans = cluster.KMeans(n_clusters=2)
# # array_data = np.array(column_x).reshape((len(data_2), 1))
# kmeans.fit(data)
# #index triés des groupes
# idk = np.argsort(kmeans.labels_)
# #affichage des observations et leurs groupes
# print(pandas.DataFrame(data.index[idk],kmeans.labels_[idk]))
# #distances aux centres de classes des observations
# print(kmeans.transform(data))

"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""


"""""""""""""""""""""""""" to determin waste of energy with CO2, fenetre and chauffage   first way   """""""""


def waste(data):
    w = np.zeros(len(data["C02"]))
    for n in range(len(data["C02"])):
        if data["C02"][n] > 1000 and data["fenetre"][n] == 1 and data["chauffage"][n] > 0:
            w[n] = 1
    return w


Waste_of_energy = waste(result)
# We create a new column to the dataframe containing the waste information

result['waste'] = Waste_of_energy

# print(result)

# We indicate the dates where there is waste of energy

for n in range(288):
    if (result["waste"][n] == 1):
        print("Gaspillage le :", result.index[n])


""""""""""""""""""""""""""""""""""""""""""""""" to determine when turn off the box in order to save energy"""""""""""""""


def box_waste(data):
    # Premièrement on discretise les valeurs
    newbox = []
    value = box['value']
    for n in range(len(value)):
        if (value[n] < 17.8):  # De manière peu rigoureuse, on a déterminerz Par lecture graphique que sous ce seuil la boxe semblait en veille

            newbox.append(0)
        else:
            newbox.append(1)

    box['newbox'] = newbox
    len_box = len(box)

    #     /!\ Puissance en dents de scie cela risque de poser problème
    #     -> on Lisse la puissance

    for i in range(len_box-2):
        if newbox[i+2] == 1 and newbox[i] == 1:
            newbox[i+1] = 1

    print(box)

    # Création d'une liste contenant des plages horaires sur lesquelles la boxe est utilisée
    liste_ALLUMAGE_globale = []
    sample = 1
    while sample <= (len_box-1):  # Pour pouvoir déterminer les heures d'allumage et d'extinction de la boxe il est nécessaire de supprimer la première et la dernière valeur
        time = box.index[sample]
        month = time.month
        day = time.day
        today = day
        the_month = month
        while the_month == month:  # 1 On récupère les mois, on fait une boucle qui tourne dans un mois
            time = box.index[sample]
            the_month = time.month
            while today == day:
                # 2 Second boucle qui tourne pour travailler avec chaque jour
                #     /!\attention le nombre de jours de chaque mois n'est pas le même,cette boucle devrait contourner le pb

                time = box.index[sample]
                today = time.day
                hour = time.hour
                minutes = time.minute
                # 3 Pour chaque jour on convertit le temps en seconde, plus facile à traiter
                time_in_sec = minutes*60+hour*3600

                # 4 On récupère les heures d'allumage et l'extinction de la boxe
                # 5 On crée des tableau Avec une heure d'allumage et une heure d'extinction
                tab_allumage = [0,0]
                if newbox[sample-1] == 0 and newbox[sample+1] == 1:
                    tab_allumage[0] = time_in_sec
                if newbox[sample-1] == 1 and newbox[sample+1] == 0:
                    tab_allumage[1] = time_in_sec

                if tab_allumage != []:
                    # On stocke tous les couples allumage/extinction dans une même liste
                    liste_ALLUMAGE_globale.append(tab_allumage)
                sample += 1

            sample += 1

    # Traitement de la liste allumage globale
    # 6 On réalise des groupes avec les heures relevées.
# Ces groupes devant contenir les heures similaires
    print (liste_ALLUMAGE_globale)
    while liste_ALLUMAGE_globale != []:
        groupe = []
        groupe.append(liste_ALLUMAGE_globale[0])
        for i in range (len(liste_ALLUMAGE_globale)):
            if abs(liste_ALLUMAGE_globale[0] - groupe[0])<3600:#Si les valeurs d'allumage sont similaires une heure près et les places dans une même liste
                groupe.append(liste_ALLUMAGE_globale[0]) 
            
        grp=[]
        grp.append(groupe) #GRP est une liste de liste, Chaque sous-groupe contient les plages horaires similaires d'allumage
        
# Calculer les heures moyenne d'allumage aux differents moment de la journée

    for i in range (len(grp)):
        moy=0
        for n in range (len(grp[i])):
            moy=moy+grp[i][n][0]
        moy =moy\(len(grp[i]))
        
        
box_waste(box)


# 6 On récupère la moyenne des valeurs de chaque groupe (centre ?) Dans la boucle

# 7 Place cette valeur dans un tableau
# (première ou seconde place en fonction de si on est dans la boucle allumage ou extinction)

# 8 Première valeur (allumage) -1800 secondes : allumage de la boxe
# Seconde valeur (Extinction) + 1800 secondes : extinction de la boxe


